
//   Sukure Halina Orvidaite, Info 4 gr  2007-04-20                      
   
/*   Uzduotis:
     
Valciu, vandens dviraciu, vandens motociklu, kateriu ir burlenciu nuoma. Be
abejo, visos plaukiojimo priemones paveldi is vienos bazines klases. Skiriasi ne
tik valandos kaina, bet ir nuolaidu skaiciavimas u papildomas valandas. Siuos
skirtumus realizuokite virtualiu metodu pagalba. Nepamirkite sukurti ir klientu
kartotekos, kad galetumete taikyti nuolaidas pastoviems klientams. Bulhalterine
knyga turi buti issaugoma ir pakraunama is failo. Nepamirskite tvarkingai istrinti
sukurtu objektu.
*/

#include <iostream>
#include <fstream>
#include <list>
#include <ctime>

#include "waterDevice.h"
#include "rent.h"

using namespace std;

const char ClsScr[]="clear";

typedef std::list<Boat*>            BoatList;
typedef std::list<WaterBike*>       WaterBikeList;
typedef std::list<WaterMotorbike*>  WaterMotorbikeList;
typedef std::list<Cutter*>          CutterList;
typedef std::list<SurfBoard*>       SurfBoardList;
typedef std::list<Rent*>            RentList; 

//----------Methods-------------------------------------------------------------

Boat*           selectBoat            (BoatList& boatList, int i);
WaterBike*      selectWaterBike       (WaterBikeList& waterBikeList, int i);
WaterMotorbike* selectWaterMotorbike  (WaterMotorbikeList& waterMotorbikeList, int i);
Cutter*         selectCutter          (CutterList& cutterList, int i);
SurfBoard*      selectSurfBoard       (SurfBoardList& surfBoardList, int i);
void rentWaterDevice                  (WaterDevice* waterDevice, RentList& rentList);
void printBoatList                    (BoatList& boatList);
void printWaterBikeList               (WaterBikeList& waterBikeList);
void printWaterMotorbikeList          (WaterMotorbikeList& waterMotorbikeList);
void printCutterList                  (CutterList& cutterList);
void printSurfBoardList               (SurfBoardList& surfBoardList);
void rentBoat                         (BoatList& boatList, RentList& rentList);
void rentWaterBike                    (WaterBikeList& waterBikeList, RentList& rentList);
void rentWaterMotorbike               (WaterMotorbikeList& waterMotorbikeList, RentList& rentList);
void rentCutter                       (CutterList& cutterList, RentList& rentList);
void rentSurfBoard                    (SurfBoardList& surfBoardList, RentList& rentList);
void unRentBoat                       (BoatList& boatList, RentList& rentList);
void unRentWaterBike                  (WaterBikeList& waterBikeList, RentList& rentList);
void unRentWaterMotorbike             (WaterMotorbikeList& waterMotorbikeList, RentList& rentList);
void unRentCutter                     (CutterList& cutterList, RentList& rentList);
void unRentSurfBoard                  (SurfBoardList& surfBoardList, RentList& rentList);
void showBoatDetails                  (BoatList& boatList);
void showWaterBikeDetails             (WaterBikeList& waterBikeList);
void showWaterMotorbikeDetails        (WaterMotorbikeList& waterMotorbikeList);
void showCutterDetails                (CutterList& cutterList);
void showSurfBoardDetails             (SurfBoardList& surfBoardList);
void showRentings                     (RentList& rentList);
int  getProfit                        (RentList& rentList);
                                                     
//----------Main program--------------------------------------------------------

int main ()
{  
   BoatList            boatList;
   WaterBikeList       waterBikeList;
   WaterMotorbikeList  waterMotorbikeList;
   CutterList          cutterList;
   SurfBoardList       surfBoardList;
   RentList            rentList; 
   
   string  name;
   string  number;
   string  status;
   string  telephone;
   string  waterDeviceName;
   string  waterDeviceNumber;
   string  rentDate;
   string  unRentDate;
   int     price;
   int     rentPrice;
   int     rentHours;
   
//-------File "Boat.txt"--------------------------------------------------------
      
   ifstream dataFileBoat ("Boat.txt");

   dataFileBoat >> name;
   while (dataFileBoat.good())     //kol pavyksta sekmingai nuskaityti
   {
      dataFileBoat >> number;
      dataFileBoat >> price;
      dataFileBoat >> status;
      boatList.push_back(new Boat(name, number, price, status));
      dataFileBoat >> name;
   }
   dataFileBoat.close();  
   
//-------File "WaterBike.txt"---------------------------------------------------

   ifstream dataFileWaterBike ("WaterBike.txt");

   dataFileWaterBike >> name;
   while (dataFileWaterBike.good())     //kol pavyksta sekmingai nuskaityti
   {
      dataFileWaterBike >> number;
      dataFileWaterBike >> price;
      dataFileWaterBike >> status;
      waterBikeList.push_back(new WaterBike(name, number, price, status));
      dataFileWaterBike >> name;
   }
   dataFileWaterBike.close();

//-------File "WaterMotorbike.txt"----------------------------------------------

   ifstream dataFileWaterMotorbike ("WaterMotorbike.txt");

   dataFileWaterMotorbike >> name;
   while (dataFileWaterMotorbike.good())     //kol pavyksta sekmingai nuskaityti
   {
      dataFileWaterMotorbike >> number;
      dataFileWaterMotorbike >> price;
      dataFileWaterMotorbike >> status;
      waterMotorbikeList.push_back(new WaterMotorbike(name, number, price, status));
      dataFileWaterMotorbike >> name;
   }
   dataFileWaterMotorbike.close();
   
//-------File "Cutter.txt"--------------------------------------------------------
      
   ifstream dataFileCutter ("Cutter.txt");

   dataFileCutter >> name;
   while (dataFileCutter.good())     //kol pavyksta sekmingai nuskaityti
   {
      dataFileCutter >> number;
      dataFileCutter >> price;
      dataFileCutter >> status;
      cutterList.push_back(new Cutter(name, number, price, status));
      dataFileCutter >> name;
   }
   dataFileCutter.close();  
   
//-------File "SurfBoard.txt"--------------------------------------------------------
      
   ifstream dataFileSurfBoard ("SurfBoard.txt");

   dataFileSurfBoard >> name;
   while (dataFileSurfBoard.good())     //kol pavyksta sekmingai nuskaityti
   {
      dataFileSurfBoard >> number;
      dataFileSurfBoard >> price;
      dataFileSurfBoard >> status;
      surfBoardList.push_back(new SurfBoard(name, number, price, status));
      dataFileSurfBoard >> name;
   }
   dataFileSurfBoard.close();  
  
//------File "Book_keeping.txt"------------------------------------------------------------------------
   ifstream dataFileBuhalt ("Book_keeping.txt");

   dataFileBuhalt >> name;
   while (dataFileBuhalt.good())     //kol pavyksta sekmingai nuskaityti
   {
      dataFileBuhalt >> telephone; 
      dataFileBuhalt >> waterDeviceName;
      dataFileBuhalt >> waterDeviceNumber;
      dataFileBuhalt >> rentDate;
      dataFileBuhalt >> unRentDate;
      dataFileBuhalt >> rentHours;
      dataFileBuhalt >> rentPrice;
      dataFileBuhalt >> status;
      
      rentList.push_back(new Rent(name, telephone, waterDeviceName, waterDeviceNumber, rentDate, unRentDate, rentHours, rentPrice, status));
      dataFileBuhalt >> name;
   }
   dataFileBuhalt.close();
   
//--------Main meniu :) --------------------------------------------------------
  
   for (;;)
   {
      cout << endl
           << "Vandens priemoniu nuoma:"                                                                  << endl
           << "  1 - Rodyti sarasa:"                                                                      << endl
           << "      1 - Valtys"                                                                          << endl
           << "      2 - Vandens dviraciai"                                                               << endl
           << "      3 - Vandens motociklai"                                                              << endl
           << "      4 - Kateriai"                                                                        << endl
           << "      5 - Burlentes"                                                                       << endl                                 
           << "  2 - Isnuomuoti:"                                                                         << endl
           << "      1 - Valtys"                                                                          << endl
           << "      2 - Vandens dviraciai"                                                               << endl
           << "      3 - Vandens motociklai"                                                              << endl
           << "      4 - Kateriai"                                                                        << endl
           << "      5 - Burlentes"                                                                       << endl           
           << "  3 - Grazinti:"                                                                           << endl
           << "      1 - Valtys"                                                                          << endl
           << "      2 - Vandens dviraciai"                                                               << endl
           << "      3 - Vandens motociklai"                                                              << endl
           << "      4 - Kateriai"                                                                        << endl
           << "      5 - Burlentes"                                                                       << endl           
           << "  4 - Detales:"                                                                            << endl
           << "      1 - Valtys"                                                                          << endl
           << "      2 - Vandens dviraciai"                                                               << endl
           << "      3 - Vandens motociklai"                                                              << endl
           << "      4 - Kateriai"                                                                        << endl
           << "      5 - Burlentes"                                                                       << endl           
           << "  5 - Visa nuoma"                                                                          << endl
           << "  6 - Pelnas"                                                                              << endl
           << "  0 - Baigti darba"                                                                        << endl
           << endl
           << "PASTABA. Rinkites MENIU ir SUBMENIU punkta. Pvz, 42 - aktyvuoja vandens dviraciu detales"  << endl
           << endl;
       string key;  
       cout<<"Jusu pasirinkimas: ";  
       cin >> key;
       if (key == "1")  {system(ClsScr); cout << "Pasirinkite 1 ir viena is SUBMENIU punktu (11, 12, 13, 14, 15)" << endl;}
       else if (key == "11") printBoatList(boatList);
       else if (key == "12") printWaterBikeList(waterBikeList);
       else if (key == "13") printWaterMotorbikeList(waterMotorbikeList);
       else if (key == "14") printCutterList(cutterList);
       else if (key == "15") printSurfBoardList(surfBoardList);              
       else if (key == "2")  {system(ClsScr); cout << "Pasirinkite 2 ir viena is SUBMENIU punktu (21, 22, 23, 24, 25)" << endl;}
       else if (key == "21") rentBoat(boatList, rentList);
       else if (key == "22") rentWaterBike(waterBikeList, rentList);
       else if (key == "23") rentWaterMotorbike(waterMotorbikeList, rentList);
       else if (key == "24") rentCutter(cutterList, rentList);
       else if (key == "25") rentSurfBoard(surfBoardList, rentList);
       else if (key == "3")  {system(ClsScr); cout << "Pasirinkite 3 ir viena is SUBMENIU punktu (31, 32, 33, 34, 35)" << endl;}
       else if (key == "31") unRentBoat(boatList, rentList);
       else if (key == "32") unRentWaterBike(waterBikeList, rentList);
       else if (key == "33") unRentWaterMotorbike(waterMotorbikeList, rentList);
       else if (key == "34") unRentCutter(cutterList, rentList);
       else if (key == "35") unRentSurfBoard(surfBoardList, rentList);
       else if (key == "4")  {system(ClsScr); cout << "Pasirinkite 4 ir viena is SUBMENIU punktu (41, 42, 43, 44, 45)" << endl;}
       else if (key == "41") showBoatDetails(boatList);
       else if (key == "42") showWaterBikeDetails(waterBikeList);
       else if (key == "43") showWaterMotorbikeDetails(waterMotorbikeList);
       else if (key == "44") showCutterDetails(cutterList);
       else if (key == "45") showSurfBoardDetails(surfBoardList);
       else if (key == "5")  showRentings(rentList);
       else if (key == "6")  getProfit(rentList);
       else if (key == "0") 
            {
                    
//---------Writing to File "Book_keeping.txt"-----------------------------------
       
   ofstream writeFile ("Book_keeping.txt");
   RentList::iterator iterRent = rentList.begin();
  
   for (;  iterRent != rentList.end();  iterRent++)
      {
         name               = (*iterRent)->getName();
         telephone          = (*iterRent)->getTelephone();
         waterDeviceName    = (*iterRent)->getWaterDeviceName();
         waterDeviceNumber  = (*iterRent)->getWaterDeviceNumber();
         rentDate           = (*iterRent)->getRentDate();
         unRentDate         = (*iterRent)->getUnRentDate();
         rentHours          = (*iterRent)->getRentHours();
         rentPrice          = (*iterRent)->getRentPrice();
         status             = (*iterRent)->getStatus();
         writeFile             << "\n"
         << name               << " "
         << telephone          << " "
         << waterDeviceName    << " "
         << waterDeviceNumber  << " "
         << rentDate           << " "
         << unRentDate         << " "
         << rentHours           << " "
         << rentPrice          << " "
         << status;
      }   
   writeFile.close();
   
//---------Writing to File "Boat.txt"-------------------------------------------
       
   ofstream writeFileBoat ("Boat.txt");
   BoatList::iterator iterBoat = boatList.begin();
  
   for (;  iterBoat != boatList.end();  iterBoat++)
      {
         name       = (*iterBoat)->getName();
         number     = (*iterBoat)->getNumber();
         price      = (*iterBoat)->getPrice();
         status     = (*iterBoat)->getStatus();
         writeFileBoat  << "\n"
         << name        << " "
         << number      << " "
         << price       << " "
         << status;
      }   
   writeFileBoat.close();
   
//---------Writing to File "WaterBike.txt"--------------------------------------
    
   ofstream writeFileWaterBike ("WaterBike.txt");
   WaterBikeList::iterator iterWaterBike = waterBikeList.begin();
  
   for (;  iterWaterBike != waterBikeList.end();  iterWaterBike++)
      {
         name       = (*iterWaterBike)->getName();
         number     = (*iterWaterBike)->getNumber();
         price      = (*iterWaterBike)->getPrice();
         status     = (*iterWaterBike)->getStatus();
         writeFileWaterBike  << "\n"
         << name             << " "
         << number           << " "
         << price            << " "
         << status;
      }   
   writeFileWaterBike.close();
   
//---------Writing to File "WaterMotorbike.txt"---------------------------------
   
   ofstream writeFileWaterMotorbike ("WaterMotorbike.txt");
   WaterMotorbikeList::iterator iterWaterMotorbike = waterMotorbikeList.begin();
  
   for (;  iterWaterMotorbike != waterMotorbikeList.end();  iterWaterMotorbike++)
      {
         name       = (*iterWaterMotorbike)->getName();
         number     = (*iterWaterMotorbike)->getNumber();
         price      = (*iterWaterMotorbike)->getPrice();
         status     = (*iterWaterMotorbike)->getStatus();
         writeFileWaterMotorbike  << "\n"
         << name                  << " "
         << number                << " "
         << price                 << " "
         << status;
      }   
   writeFileWaterMotorbike.close();
   
//---------Writing to File "Cutter.txt"-----------------------------------------
   
   ofstream writeFileCutter ("Cutter.txt");
   CutterList::iterator iterCutter = cutterList.begin();
  
   for (;  iterCutter != cutterList.end();  iterCutter++)
      {
         name       = (*iterCutter)->getName();
         number     = (*iterCutter)->getNumber();
         price      = (*iterCutter)->getPrice();
         status     = (*iterCutter)->getStatus();
         writeFileCutter  << "\n"
         << name          << " "
         << number        << " "
         << price         << " "
         << status;
      }   
   writeFileCutter.close();
   
//---------Writing to File "SurfBoard.txt"--------------------------------------
   
   ofstream writeFileSurfBoard ("SurfBoard.txt");
   SurfBoardList::iterator iterSurfBoard = surfBoardList.begin();
  
   for (;  iterSurfBoard != surfBoardList.end();  iterSurfBoard++)
      {
         name       = (*iterSurfBoard)->getName();
         number     = (*iterSurfBoard)->getNumber();
         price      = (*iterSurfBoard)->getPrice();
         status     = (*iterSurfBoard)->getStatus();
         writeFileSurfBoard  << "\n"
         << name             << " "
         << number           << " "
         << price            << " "
         << status;
      }   
   writeFileSurfBoard.close();
   
//---------Delete for all lists-------------------------------------------------
       
    for (; iterBoat != boatList.end(); iterBoat++)
       delete (*iterBoat);  
    for (; iterWaterBike != waterBikeList.end(); iterWaterBike++)
       delete (*iterWaterBike);   
    for (; iterWaterMotorbike != waterMotorbikeList.end(); iterWaterMotorbike++)
       delete (*iterWaterMotorbike); 
    for (; iterCutter != cutterList.end(); iterCutter++)
       delete (*iterCutter); 
    for (; iterSurfBoard != surfBoardList.end(); iterSurfBoard++)
       delete (*iterSurfBoard);               
    for (; iterRent != rentList.end(); iterRent++)
       delete (*iterRent); 
    return 0;
      }         
    else {system(ClsScr); cout << endl << "Neteisinga komanda..." << endl;}  
    } 
       
}

//---------SelectBoat() method--------------------------------------------------

Boat* selectBoat (BoatList& boatList, int i)
{
   if (i == 0)
   {
      for (;;)
      {
         string num;
        cout << "Tikrai norite issinuomoti valti? ('t'-testi, 'q'-atsaukti) " << endl;
        cin  >> num;
        if (num == "q")
        {
            system(ClsScr);
            return 0;
        }
        if (num == "t")
        {    
            BoatList::iterator iter = boatList.begin();
            for (;  iter != boatList.end(); iter++)
            {
                 if ((*iter)->getStatus().at(0) != 'I')
                     return *iter;
            }
            system(ClsScr);   
            cout << "Atsiprasome, bet visos valtys siuo metu yra isnuomotos." << endl;     
            return 0;
        }
        system(ClsScr);   
        cout << "Apsispreskite." << endl; 
     }
   }
   if (i == 1)
   {
      for (;;)
      {
          string num;
          printBoatList(boatList);
          cout << endl;
          cout << "Issirinkite valties numeri ('q'-atsaukti): " << endl;
          cout << "Numeris          : ";
          cin >> num;
          if (num == "q")
          {
              system(ClsScr);
              return 0;
          }    
          BoatList::iterator iter = boatList.begin();
          for (;  iter != boatList.end(); iter++)
          {
               if (num == (*iter)->getNumber())
               return *iter;
          }    
          system(ClsScr);   
          cout << "Tokios valties nera. Bandykite dar karta" << endl; 
       }
   }
   return 0; 
}  

//---------SelectWaterBike() method--------------------------------------------------

WaterBike* selectWaterBike (WaterBikeList& waterBikeList, int i)
{
   if (i == 0)
   {
      for (;;)
      {
          string num;
          cout << "Tikrai norite issinuomoti vandens dvirati? ('t'-testi, 'q'-atsaukti) " << endl;
          cin  >> num;
          if (num == "q")
          {
             system(ClsScr);
             return 0;
          }
          if (num == "t")
          {    
             WaterBikeList::iterator iter = waterBikeList.begin();
             for (;  iter != waterBikeList.end(); iter++)
             {
                 if ((*iter)->getStatus().at(0) != 'I')
                    return *iter;
             }
             system(ClsScr);   
             cout << "Atsiprasome, bet visi vandens dviraciai siuo metu yra isnuomoti." << endl;     
             return 0;
          }
          system(ClsScr);   
          cout << "Apsispreskite." << endl; 
      }
   }
   if (i == 1)
   {
      for (;;)
      {
          string num;
          printWaterBikeList(waterBikeList);
          cout << endl;
          cout << "Issirinkite vandens dviracio numeri ('q'-atsaukti): " << endl;
          cout << "Numeris          : ";
          cin >> num;
          if (num == "q")
          {
             system(ClsScr);
             return 0;
          }    
          WaterBikeList::iterator iter = waterBikeList.begin();
          for (;  iter != waterBikeList.end(); iter++)
          {
              if (num == (*iter)->getNumber())
              return *iter;
          }    
          system(ClsScr);   
          cout << "Tokio vandens dviracio nera. Bandykite dar karta" << endl; 
      }
   }
   return 0; 
}  

//---------SelectWaterMotorbike() method--------------------------------------------------

WaterMotorbike* selectWaterMotorbike (WaterMotorbikeList& waterMotorbikeList, int i)
{
   if (i == 0)
   {
      for (;;)
      {
          string num;
          cout << "Tikrai norite issinuomoti vandens motocikla? ('t'-testi, 'q'-atsaukti) " << endl;
          cin  >> num;
          if (num == "q")
          {
             system(ClsScr);
             return 0;
          }
          if (num == "t")
          {    
             WaterMotorbikeList::iterator iter = waterMotorbikeList.begin();
             for (;  iter != waterMotorbikeList.end(); iter++)
             {
                 if ((*iter)->getStatus().at(0) != 'I')
                    return *iter;
             }
             system(ClsScr);   
             cout << "Atsiprasome, bet visi vandens motociklai siuo metu yra isnuomoti." << endl;     
             return 0;
          }
          system(ClsScr);   
          cout << "Apsispreskite." << endl; 
      }
   }
   if (i == 1)
   {
      for (;;)
      {
          string num;
          printWaterMotorbikeList(waterMotorbikeList);
          cout << endl;
          cout << "Issirinkite vandens motociklo numeri ('q'-atsaukti): " << endl;
          cout << "Numeris          : ";
          cin >> num;
          if (num == "q")
          {
             system(ClsScr);
             return 0;
          }    
          WaterMotorbikeList::iterator iter = waterMotorbikeList.begin();
          for (;  iter != waterMotorbikeList.end(); iter++)
          {
              if (num == (*iter)->getNumber())
                 return *iter;
          }    
          system(ClsScr);   
          cout << "Tokio vandens motociklo nera. Bandykite dar karta" << endl; 
      }
   }
   return 0; 
}  

//---------SelectCutter() method--------------------------------------------------

Cutter* selectCutter (CutterList& cutterList, int i)
{
   if (i == 0)
   {
      for (;;)
      {
          string num;
          cout << "Tikrai norite issinuomoti kateri? ('t'-testi, 'q'-atsaukti) " << endl;
          cin  >> num;
          if (num == "q")
          {
             system(ClsScr);
             return 0;
          }
          if (num == "t")
          {    
             CutterList::iterator iter = cutterList.begin();
             for (;  iter != cutterList.end(); iter++)
             {
                 if ((*iter)->getStatus().at(0) != 'I')
                    return *iter;
             }
             system(ClsScr);   
             cout << "Atsiprasome, bet visi kateriai siuo metu yra isnuomoti." << endl;     
             return 0;
          }
          system(ClsScr);   
          cout << "Apsispreskite." << endl; 
      }
   }
   if (i == 1)
   {
      for (;;)
      {
          string num;
          printCutterList(cutterList);
          cout << endl;
          cout << "Issirinkite katerio numeri ('q'-atsaukti): " << endl;
          cout << "Numeris          : ";
          cin >> num;
          if (num == "q")
          {
             system(ClsScr);
             return 0;
          }    
          CutterList::iterator iter = cutterList.begin();
          for (;  iter != cutterList.end(); iter++)
          {
              if (num == (*iter)->getNumber())
                 return *iter;
          }    
           
          system(ClsScr);   
          cout << "Tokio katerio nera. Bandykite dar karta" << endl; 
      }
   }
   return 0; 
}  

//---------SelectSurfBoard() method--------------------------------------------------

SurfBoard* selectSurfBoard (SurfBoardList& surfBoardList, int i)
{
   if (i == 0)
   {
      for (;;)
      {
          string num;
          cout << "Tikrai norite issinuomoti burlente? ('t'-testi, 'q'-atsaukti) " << endl;
          cin  >> num;
          if (num == "q")
          {
             system(ClsScr);
             return 0;
          }
          if (num == "t")
          {    
             SurfBoardList::iterator iter = surfBoardList.begin();
             for (;  iter != surfBoardList.end(); iter++)
             {
                 if ((*iter)->getStatus().at(0) != 'I')
                    return *iter;
             }
             system(ClsScr);   
             cout << "Atsiprasome, bet visos burlentes siuo metu yra isnuomotos." << endl;     
             return 0;
          }
          system(ClsScr);   
          cout << "Apsispreskite." << endl; 
      }
   }
   if (i == 1)
   {
      for (;;)
      {
          string num;
          printSurfBoardList(surfBoardList);
          cout << endl;
          cout << "Issirinkite burlentes numeri ('q'-atsaukti): " << endl;
          cout << "Numeris          : ";
          cin >> num;
          if (num == "q")
          {
             system(ClsScr);
             return 0;
          }    
          SurfBoardList::iterator iter = surfBoardList.begin();
          for (;  iter != surfBoardList.end(); iter++)
          {
              if (num == (*iter)->getNumber())
                 return *iter;
          }    
          system(ClsScr);   
          cout << "Tokios burlentes nera. Bandykite dar karta" << endl; 
      }
   }
   return 0; 
}  

//------BoatList print()--------------------------------------------------------

void printBoatList (BoatList& boatList)
{ 
   int n = 0;
   system(ClsScr);
   cout << "\t\t\t\t Valciu sarasas"                                 << endl;
   cout << "\t======================================================="   << endl; 
   cout << "\t|Nr.| \t Pavadinimas\t     | Numeris |   Statusas   |"     << endl;
   cout << "\t======================================================="   << endl;
  
   BoatList::iterator iter = boatList.begin();
   for (n = 1; iter != boatList.end(), n <= boatList.size(); iter++, n++)
      { 
         cout << "\t  " << n;
         (*iter)->print();
      }
} 

//-------WaterBikeList print()--------------------------------------------------

void printWaterBikeList (WaterBikeList& waterBikeList)
{ 
   int n = 0;
   system(ClsScr);
   cout << "\t\t\t\t Vandens dviraciu sarasa"                      << endl;
   cout << "\t=============================================================" << endl; 
   cout << "\t|Nr.| \t Pavadinimas\t\t   | Numeris |   Statusas   |"   << endl;
   cout << "\t=============================================================" << endl;
  
   WaterBikeList::iterator iter = waterBikeList.begin();
   for (n = 1; iter != waterBikeList.end(), n <= waterBikeList.size(); iter++, n++)
      { 
         cout << "\t  " << n;
         (*iter)->print();
      }
} 

//---------WaterMotorbikeList print()-------------------------------------------

void printWaterMotorbikeList (WaterMotorbikeList& waterMotorbikeList)
{ 
   int n = 0;
   system(ClsScr);
   cout << "\t\t\t\t Vandens motociklu sarasas"                << endl;
   cout << "\t===========================================================" << endl; 
   cout << "\t|Nr.| \t Pavadinimas\t\t   | Numeris |  Statusas  |"   << endl;
   cout << "\t===========================================================" << endl;
  
   WaterMotorbikeList::iterator iter = waterMotorbikeList.begin();
   for (n = 1; iter != waterMotorbikeList.end(), n <= waterMotorbikeList.size(); iter++, n++)
      { 
         cout << "\t  " << n;
         (*iter)->print();
      }
}

//---------CutterList print()---------------------------------------------------

void printCutterList (CutterList& cutterList)
{ 
   int n = 0;
   system(ClsScr);
   cout << "\t\t\t\t Kateriu sarasas"                          << endl;
   cout << "\t=====================================================" << endl; 
   cout << "\t|Nr.| \t Pavadinimas\t   | Numeris |   Statusas   |"   << endl;
   cout << "\t=====================================================" << endl;
  
   CutterList::iterator iter = cutterList.begin();
   for (n = 1; iter != cutterList.end(), n <= cutterList.size(); iter++, n++)
      { 
         cout << "\t  " << n;
         (*iter)->print();
      }
} 

//---------SurfBoradList print()------------------------------------------------

void printSurfBoardList (SurfBoardList& surfBoardList)
{ 
   int n = 0;
   system(ClsScr);
   cout << "\t\t\t\t Burlenciu sarasas"                        << endl;
   cout << "\t===================================================" << endl; 
   cout << "\t|Nr.| \t Pavadinimas\t   | Numeris |  Statusas  |"   << endl;
   cout << "\t===================================================" << endl;
  
   SurfBoardList::iterator iter = surfBoardList.begin();
   for (n = 1; iter != surfBoardList.end(), n <= surfBoardList.size(); iter++, n++)
      { 
         cout << "\t  " << n;
         (*iter)->print();
      }
}  

//-----------RentBoat method()--------------------------------------------------

void rentBoat (BoatList& boatList, RentList& rentList)
{
   system(ClsScr);
   cout << "\t\t\t\t Valciu nuoma" << endl;
   
   Boat* boat = selectBoat(boatList, 0); 
   if (boat == 0) return;

   rentWaterDevice(boat, rentList);
}

//-----------RentWaterBike method()---------------------------------------------

void rentWaterBike (WaterBikeList& waterBikeList, RentList& rentList)
{
   system(ClsScr);
   cout << "\t\t\t\t Vandens dviraciu nuoma" << endl;
   
   WaterBike* waterBike = selectWaterBike(waterBikeList, 0); 
   if (waterBike == 0) return;
   
   rentWaterDevice(waterBike, rentList);
}

//-----------RentWaterMotorbike method()--------------------------------------------------

void rentWaterMotorbike (WaterMotorbikeList& waterMotorbikeList, RentList& rentList)
{
   system(ClsScr);
   cout << "\t\t\t\t Vandens motociklu nuoma" << endl;
   
   WaterMotorbike* waterMotorbike = selectWaterMotorbike(waterMotorbikeList, 0); 
   if (waterMotorbike == 0) return;
   
   rentWaterDevice(waterMotorbike, rentList);
}

//-----------RentCutter method()--------------------------------------------------

void rentCutter (CutterList& cutterList, RentList& rentList)
{
   system(ClsScr);
   cout << "\t\t\t\t Kateriu nuoma" << endl;
   
   Cutter* cutter = selectCutter(cutterList, 0); 
   if (cutter == 0) return;
   
   rentWaterDevice(cutter, rentList);

}

//-----------RentSurfBoard method()--------------------------------------------------

void rentSurfBoard (SurfBoardList& surfBoardList, RentList& rentList)
{

   system(ClsScr);
   cout << "\t\t\t\t Burlenciu nuoma" << endl;
   
   SurfBoard* surfBoard = selectSurfBoard(surfBoardList, 0); 
   if (surfBoard == 0) return;
   
   rentWaterDevice(surfBoard, rentList);
   
}

//---------Rent waterDevice method----------------------------------------------

void rentWaterDevice (WaterDevice* waterDevice, RentList& rentList)
{
   time_t laikas;
   struct tm *timeinfo;     //isgauti laikui
   
   string name;
   string telephone;
   int    rentHours;
   int    rentPrice;
   int    price;
   
   cout << "Kliento vardas         : ";    cin >> name;
   cout << "Kliento telefonas      : ";    cin >> telephone;
   cout << "Nuomos valandu skaicius: ";    cin >> rentHours;

   system(ClsScr);
   cout << "Sekmingai isnuomuota";
   cout << endl;
   
   time (&laikas);
   timeinfo = localtime (&laikas);

   waterDevice->setStatus("Isnuomuota");
   string waterDeviceName   = waterDevice->getName();
   string waterDeviceNumber = waterDevice->getNumber();
   rentPrice = waterDevice->getRentPrice(rentHours);
   
   Rent* rent = new Rent(name, telephone, waterDeviceName, waterDeviceNumber, *timeinfo, rentHours, rentPrice);
   waterDevice->addRent(rent);
   rentList.push_back(rent);
   
   price = waterDevice->getPrice();
   cout << endl << "Valandos kaina           : " << price
        << endl << "Jusu mokestis uz valanda : " << rentPrice
        << endl << "* Viso moketi            : " << rent->getRentProfit()
        << endl;
}


//---------Boat returning method------------------------------------------------

void unRentBoat (BoatList& boatList, RentList& rentList)
{
   time_t  laikas;
   struct  tm *timeinfo;
  
   system(ClsScr);
   cout << "\t\t\t\t Valties grazinimas" << endl;
   
   Boat* boat = selectBoat(boatList, 1);
   if (boat == 0) return;
   if (boat->getStatus() == "Laisva")
      {  
         system(ClsScr);
         cout << "Si valtis neisnuomuota\n";    
         return;
      }
         
   boat->setStatus("Laisva");
    
   RentList::iterator iter = rentList.begin();
      for (;  iter != rentList.end();  iter++)
         {
             if (boat->getNumber() == (*iter)->getWaterDeviceNumber())
             break;
         }    
         
   time (&laikas);
   timeinfo = localtime (&laikas);   
   
   (*iter)->setStatus("Grazinta");
   (*iter)->setBackDate(*timeinfo);
  
   system(ClsScr);
   cout << "Valtis grazinta sekmingai\n";  
} 

//---------WaterBike returning method-------------------------------------------

void unRentWaterBike (WaterBikeList& waterBikeList, RentList& rentList)
{
   time_t  laikas;
   struct  tm *timeinfo; 
  
   system(ClsScr);
   cout << "\t\t\t\t Vandens dviracio grazinimas" << endl;
   
   WaterBike* waterBike = selectWaterBike(waterBikeList, 1);
   if (waterBike == 0) return;
   if (waterBike->getStatus() == "Laisvas")
      {  
         system(ClsScr);
         cout << "Sis vandens dviratis neisnuomuotas\n";    
         return;
      }
         
   waterBike->setStatus("Laisvas");
    
   RentList::iterator iter = rentList.begin();
      for (;  iter != rentList.end();  iter++)
         {
             if (waterBike->getNumber() == (*iter)->getWaterDeviceNumber())
             break;
         }    
         
   time (&laikas);
   timeinfo = localtime (&laikas);   
   
   (*iter)->setStatus("Grazintas");
   (*iter)->setBackDate(*timeinfo);
  
   system(ClsScr);
   cout << "Vandens dviratis grazintas sekmingai\n";  
} 

//---------WaterMotorbike returning method--------------------------------------

void unRentWaterMotorbike (WaterMotorbikeList& waterMotorbikeList, RentList& rentList)
{
   time_t  laikas;
   struct  tm *timeinfo; 
  
   system(ClsScr);
   cout << "\t\t\t\t Vandens motociklo grazinimas" << endl;
   
   WaterMotorbike* waterMotorbike = selectWaterMotorbike(waterMotorbikeList, 1);
   if (waterMotorbike == 0) return;
   if (waterMotorbike->getStatus() == "Laisvas")
      {  
         system(ClsScr);
         cout << "Sis vandens motociklas neisnuomuotas\n";    
         return;
      }
         
   waterMotorbike->setStatus("Laisvas");
    
   RentList::iterator iter = rentList.begin();
      for (;  iter != rentList.end();  iter++)
         {
             if (waterMotorbike->getNumber() == (*iter)->getWaterDeviceName())
             break;
         }    
         
   time (&laikas);
   timeinfo = localtime (&laikas);   
   
   (*iter)->setStatus("Grazintas");
   (*iter)->setBackDate(*timeinfo);
  
   system(ClsScr);
   cout << "Vandens motociklas grazintas sekmingai\n";  
}

//---------Cutter returning method----------------------------------------------

void unRentCutter (CutterList& cutterList, RentList& rentList)
{
   time_t  laikas;
   struct  tm *timeinfo;
  
   system(ClsScr);
   cout << "\t\t\t\t Katerio grazinimas" << endl;
   
   Cutter* cutter = selectCutter(cutterList, 1);
   if (cutter == 0) return;
   if (cutter->getStatus() == "Laisvas")
      {  
         system(ClsScr);
         cout << "Sis kateris neisnuomuotas\n";    
         return;
      }
         
   cutter->setStatus("Laisvas");
    
   RentList::iterator iter = rentList.begin();
      for (;  iter != rentList.end();  iter++)
         {
             if (cutter->getNumber() == (*iter)->getWaterDeviceNumber())
             break;
         }    
         
   time (&laikas);
   timeinfo = localtime (&laikas);   
   
   (*iter)->setStatus("Grazintas");
   (*iter)->setBackDate(*timeinfo);
  
   system(ClsScr);
   cout << "Kateris grazintas sekmingai\n";  
} 

//---------SurfBoard returning method-------------------------------------------

void unRentSurfBoard (SurfBoardList& surfBoardList, RentList& rentList)
{
   time_t  laikas;
   struct  tm *timeinfo;
  
   system(ClsScr);
   cout << "\t\t\t\t Burlentes grazinimas" << endl;
   
   SurfBoard* surfBoard = selectSurfBoard(surfBoardList, 1);
   if (surfBoard == 0) return;
   if (surfBoard->getStatus() == "Laisva")
      {  
         system(ClsScr);
         cout << "Si burlente neisnuomuota\n";    
         return;
      }
         
   surfBoard->setStatus("Laisva");
    
   RentList::iterator iter = rentList.begin();
      for (;  iter != rentList.end();  iter++)
         {
             if (surfBoard->getNumber() == (*iter)->getWaterDeviceNumber())
             break;
         }    
         
   time (&laikas);
   timeinfo = localtime (&laikas);   
   
   (*iter)->setStatus("Grazinta");
   (*iter)->setBackDate(*timeinfo);
  
   system(ClsScr);
   cout << "Burlente grazinta sekmingai\n";  
}  

//-------Show Boats Details-----------------------------------------------------

void showBoatDetails (BoatList& boatList)
{
   system(ClsScr);
   cout << "\t\t\t\t Valciu detales" << endl;
   Boat* boat = selectBoat(boatList, 1);
   if (boat == 0) return;

   system(ClsScr);
   cout << "\t\t\t\t Valciu detales"      << endl;
   cout << "Valties " << boat->getNumber() << " detales" << endl;
   boat->printDetails();
}

//-------Show WaterBikes Details------------------------------------------------

void showWaterBikeDetails (WaterBikeList& waterBikeList)
{
   system(ClsScr);
   cout << "\t\t\t\t Vandens dviraciu detales" << endl;
   WaterBike* waterBike = selectWaterBike(waterBikeList, 1);
   if (waterBike == 0) return;

   system(ClsScr);
   cout << "\t\t\t\t Vandens dviraciu detales"      << endl;
   cout << "Vandens dviracio " << waterBike->getNumber() << " detales" << endl;
   waterBike->printDetails();
}

//-------Show WaterMotorbikes Details-------------------------------------------

void showWaterMotorbikeDetails (WaterMotorbikeList& waterMotorbikeList)
{
   system(ClsScr);
   cout << "\t\t\t\t Vandens motociklu detales" << endl;
   WaterMotorbike* waterMotorbike = selectWaterMotorbike(waterMotorbikeList, 1);
   if (waterMotorbike == 0) return;

   system(ClsScr);
   cout << "\t\t\t\t Vandens motociklu detales"      << endl;
   cout << "Vandens motociklo " << waterMotorbike->getNumber() << " detales" << endl;
   waterMotorbike->printDetails();
}

//-------Show Cutters Details---------------------------------------------------

void showCutterDetails (CutterList& cutterList)
{
   system(ClsScr);
   cout << "\t\t\t\t Kateriu detales" << endl;
   Cutter* cutter = selectCutter(cutterList, 1);
   if (cutter == 0) return;

   system(ClsScr);
   cout << "\t\t\t\t Kateriu detales"      << endl;
   cout << "Katerio " << cutter->getNumber() << " detales" << endl;
   cutter->printDetails();
}

//-------Show SurfBoards Details------------------------------------------------

void showSurfBoardDetails (SurfBoardList& surfBoardList)
{
   system(ClsScr);
   cout << "\t\t\t\t Burlenciu detales" << endl;
   SurfBoard* surfBoard = selectSurfBoard(surfBoardList, 1);
   if (surfBoard == 0) return;

   system(ClsScr);
   cout << "\t\t\t\t Burlenciu detales"      << endl;
   cout << "Burlentes " << surfBoard->getNumber() << " detales" << endl;
   surfBoard->printDetails();
}

//------Rentings list-----------------------------------------------------------

void showRentings (RentList& rentList)
{
    RentList::iterator iter = rentList.begin();
    system(ClsScr);
    cout << "\t\t\t     Visa nuoma \n\n";
    cout << "Nuomuotojas  Telefonas  Vandens priemone  Numeris  Issinuomavo  Grazino    Statusas     Moketa" << endl;
    
    for (;  iter != rentList.end();  iter++)
      {
         cout << (*iter)->getName();
         for (int i = 0; i < (13 - (*iter)->getName().length()); i++)
         cout << " ";
         cout << (*iter)->getTelephone();
         for (int i = 0; i < (11 - (*iter)->getTelephone().length()); i++)
         cout << " ";
         cout << (*iter)->getWaterDeviceName();
         for (int i = 0; i < (18 - (*iter)->getWaterDeviceName().length()); i++)
         cout << " ";
         cout << (*iter)->getWaterDeviceNumber();
         for (int i = 0; i < (9 - (*iter)->getWaterDeviceNumber().length()); i++)
         cout << " ";
         cout << (*iter)->getRentDate();
         for (int i = 0; i < (13 - (*iter)->getRentDate().length()); i++)
         cout << " ";
         cout << (*iter)->getUnRentDate();
         for (int i = 0; i < (11 - (*iter)->getUnRentDate().length()); i++)
         cout << " ";
         cout << (*iter)->getStatus();
         for (int i = 0; i < (13 - (*iter)->getStatus().length()); i++)
         cout << " ";
         cout << (*iter)->getRentProfit() << " Lt" << endl;
      }
}    

//--------Show profit-----------------------------------------------------------

int getProfit (RentList& rentList)
{
   int profit = 0; 
   RentList::iterator iterRent = rentList.begin(); 
   system(ClsScr);
   cout << "\t\t\t Bendras pelnas \n\n";
   
   for (; iterRent != rentList.end(); iterRent++)
      {
         profit+=(*iterRent)->getRentProfit();
      }
   cout << "Pelnas yra: " << profit << " Lt" << endl;  
   return profit;
}

//==============================================================================
