
//   Sukure Halina Orvidaite, Info 4 gr  2007-04-20                      
   
/*   Uzduotis:
     
Valciu, vandens dviraciu, vandens motociklu, kateriu ir burlenciu nuoma. Be
abejo, visos plaukiojimo priemones paveldi is vienos bazines klases. Skiriasi ne
tik valandos kaina, bet ir nuolaidu skaiciavimas u papildomas valandas. Siuos
skirtumus realizuokite virtualiu metodu pagalba. Nepamirkite sukurti ir klientu
kartotekos, kad galetumete taikyti nuolaidas pastoviems klientams. Bulhalterine
knyga turi buti issaugoma ir pakraunama is failo. Nepamirskite tvarkingai istrinti
sukurtu objektu.
*/

#include <iostream>

#include "waterDevice.h"

using namespace std;


//-------WaterDevice------------------------------------------------------------

WaterDevice::WaterDevice(const string& name,
                         const string& number,
                         int&  price,
                         const string& status)
             
   : name     (name),
     number   (number),
     price    (price),
     status   (status)
{
}

//-------Boat from WaterDevice--------------------------------------------------

Boat::Boat(const string& name,
           const string& number,
           int&  price,
           const string& status)
            
   : WaterDevice (name, number, price, status)
{
}

//-------WaterBike from WaterDevice---------------------------------------------

WaterBike::WaterBike(const string& name,
                     const string& number,
                     int&  price,
                     const string& status)
         
   : WaterDevice (name, number, price, status)
{
}

//-------WaterMotorbike from WaterDevice----------------------------------------

WaterMotorbike::WaterMotorbike(const string& name,
                               const string& number,
                               int&  price,
                               const string& status)  

   : WaterDevice (name, number, price, status)
{
}

//-------Cutter from WaterDevice------------------------------------------------

Cutter::Cutter(const string& name,
               const string& number,
               int&  price,
               const string& status)  

   : WaterDevice (name, number, price, status)
{
}

//-------Surfboard from WaterDevice---------------------------------------------

SurfBoard::SurfBoard(const string& name,
                     const string& number,
                     int&  price,
                     const string& status)  

   : WaterDevice (name, number, price, status)
{
}

//-------Boat Print-------------------------------------------------------------

void Boat::print()
{  
   string temp = "   ";     //lenteles sulygiavimui
   int length;
   
   if (this->name.length() <  7)
       cout << "\t " << this->name << temp << "\t\t";
   else
       cout << "\t " << this->name << "\t     ";
       cout << this->number << "\t ";
       cout << this->getStatus() << endl;
}

//-------WaterBike Print()------------------------------------------------------

void WaterBike::print()
{  
   int length;
   
   if (this->name.length() <  7)
       cout << "\t " << this->name << "\t\t     ";
   else
       cout << "\t " << this->name << "\t     ";
       cout << this->number << "       ";
       cout << this->getStatus() << endl;
}

//-------WaterMotorbike Print()-------------------------------------------------

void WaterMotorbike::print()
{  
   string temp = "     ";     //lenteles sulygiavimui
   int length;
   if (this->name.length() <  7)
   cout << "\t " << this->name << "\t\t" << temp;
   else
   cout << "\t " << this->name << "\t     ";
   cout << this->number << "\t";
   cout << this->getStatus() << endl;
}

//-------Cutter Print()---------------------------------------------------------

void Cutter::print()
{  
   string temp = "     ";     //lenteles sulygiavimui
   int length;
   if (this->name.length() <  7)
   cout << "\t " << this->name << "\t\t" << temp;
   else
   cout << "\t " << this->name << "\t     ";
   cout << this->number << "\t";
   cout << this->getStatus() << endl;
}

//-------Surfboard Print()-------------------------------------------------

void SurfBoard::print()
{  
   string temp = "     ";     //lenteles sulygiavimui
   int length;
   if (this->name.length() <  7)
   cout << "\t " << this->name << "\t\t" << temp;
   else
   cout << "\t " << this->name << "\t     ";
   cout << this->number << "\t";
   cout << this->getStatus() << endl;
}

//--------Boat Details Print()--------------------------------------------------

void Boat::printDetails() 
{
   cout << endl;
   cout << "Pavadinimas         : "  << getName()        << endl;
   cout << "Numeris             : "  << getNumber()      << endl;
   cout << "Valandos kaina      : "  << getPrice()       << endl;
}

//---------WaterBike Details Print()--------------------------------------------

void WaterBike::printDetails() 
{
   cout << endl;
   cout << "Pavadinimas         : "  << getName()        << endl;
   cout << "Numeris             : "  << getNumber()      << endl;
   cout << "Valandos kaina      : "  << getPrice()       << endl;
}

//---------WaterMotorbike Details Print()---------------------------------------

void WaterMotorbike::printDetails() 
{
   cout << endl;
   cout << "Pavadinimas         : "  << getName()        << endl;
   cout << "Numeris             : "  << getNumber()      << endl;
   cout << "Valandos kaina      : "  << getPrice()       << endl;
}

//---------Cutter Details Print()-----------------------------------------------

void Cutter::printDetails() 
{
   cout << endl;
   cout << "Pavadinimas         : "  << getName()        << endl;
   cout << "Numeris             : "  << getNumber()      << endl;
   cout << "Valandos kaina      : "  << getPrice()       << endl;
}

//---------Surfboard Details Print()---------------------------------------

void SurfBoard::printDetails() 
{
   cout << endl;
   cout << "Pavadinimas         : "  << getName()        << endl;
   cout << "Numeris             : "  << getNumber()      << endl;
   cout << "Valandos kaina      : "  << getPrice()       << endl;
}

//---------Boat Price + Discount------------------------------------------------

int Boat::getRentPrice (int rentHours)
{
     int     discount;
     int     price;
     
     price = getPrice();
     
     if (rentHours > 10)
       {
         discount = price - 2;
         return discount;  
       }
     else
       return price; 
}

//---------WaterBike Price + Discount-------------------------------------------

int WaterBike::getRentPrice(int rentHours)
{
     int     discount;
     int     price;
     
     price = getPrice();
     
     return price;
}

//---------WaterMotorbike Price + Discount--------------------------------------

int WaterMotorbike::getRentPrice(int rentHours)
{
     int     discount;
     int     price;
     
     price = getPrice();
     
     if (rentHours > 7)
       {
         discount = price - 5;
         return discount;  
       }
     else
       {
         return price;
       }
}

//---------Cutter Price + Discount----------------------------------------------

int Cutter::getRentPrice(int rentHours)
{
     int     discount;
     int     price;
     
     price = getPrice();
     
     if (rentHours > 3)
       {
         discount = price - 10;
         return discount;  
       }
     else
       {
         return price;
       }
}

//---------SurfBoard Price + Discount-------------------------------------------

int SurfBoard::getRentPrice(int rentHours)
{
     int     discount;
     int     price;
     
     price = getPrice();
     
     if (rentHours > 8)
       {
         discount = price - 3;
         return discount;  
       }
     else
       {
         return price;
       }
}

//----------Add new rent--------------------------------------------------------

void WaterDevice::addRent(Rent* rent)
{
   rentList.push_back(rent);
}

//==============================================================================

