
//   Sukure Halina Orvidaite, Info 4 gr  2007-04-20                      
   
/*   Uzduotis:
     
Valciu, vandens dviraciu, vandens motociklu, kateriu ir burlenciu nuoma. Be
abejo, visos plaukiojimo priemones paveldi is vienos bazines klases. Skiriasi ne
tik valandos kaina, bet ir nuolaidu skaiciavimas u papildomas valandas. Siuos
skirtumus realizuokite virtualiu metodu pagalba. Nepamirkite sukurti ir klientu
kartotekos, kad galetumete taikyti nuolaidas pastoviems klientams. Bulhalterine
knyga turi buti issaugoma ir pakraunama is failo. Nepamirskite tvarkingai istrinti
sukurtu objektu.
*/

#ifndef __waterDevice_h
#define __waterDevice_h

#include <string>
#include <list>

#include "rent.h"

//------Class WaterDevice-------------------------------------------------------


class WaterDevice
{
protected:

   std::string           name;
   std::string           number;
   std::string           status;
   int                   price;
   
   std::list<Rent*>      rentList;

public:

   WaterDevice(const std::string& name,
               const std::string& number,
               int&  price,
               const std::string& status);
  
   void          setStatus           (std::string status) {this->status = status;}
   void          addRent             (Rent* rent);
   virtual void  print               () {;} 
   virtual void  printDetails        () {;}
   virtual int   getPrice            () {return this->price;} 
   std::string   getName             () {return this->name;}
   std::string   getStatus           () {return this->status;}
   std::string   getNumber           () {return this->number;}
   virtual int   getRentPrice        (int rentHours) = 0;
};

//-------Class Boat from WaterDevice--------------------------------------------

class Boat: public WaterDevice
{
public:

   Boat(const std::string& name,
        const std::string& number,
        int&  price,
        const std::string& status);
   
   virtual int  getRentPrice        (int rentHours);
   virtual void print               ();
   virtual void printDetails        ();
};

//-------Class WaterBike from WaterDevice---------------------------------------

class WaterBike: public WaterDevice
{
public:

   WaterBike(const std::string& name,
             const std::string& number,
             int&  price,
             const std::string& status);
  
   virtual int  getRentPrice        (int rentHours);
   virtual void print               ();
   virtual void printDetails        ();
};

//-------Class WaterMotorbike form WaterDevice----------------------------------

class WaterMotorbike: public WaterDevice
{
public:

   WaterMotorbike(const std::string& name,
                  const std::string& number,
                  int&  price,
                  const std::string& status);
  
   virtual int  getRentPrice        (int rentHours);
   virtual void print               ();
   virtual void printDetails        ();
};

//-------Class Cutter form WaterDevice------------------------------------------

class Cutter: public WaterDevice
{
public:

   Cutter(const std::string& name,
          const std::string& number,
          int&  price,
          const std::string& status);
  
   virtual int  getRentPrice        (int rentHours);
   virtual void print               ();
   virtual void printDetails        ();
};

//-------Class SurfBoard form WaterDevice---------------------------------------

class SurfBoard: public WaterDevice
{
public:

   SurfBoard(const std::string& name,
             const std::string& number,
             int&  price,
             const std::string& status);
  
   virtual int  getRentPrice        (int rentHours);
   virtual void print               ();
   virtual void printDetails        ();
};

#endif

//==============================================================================
